var Dimensions;
var NewDimensions;
var Padding;

var Canvas;
var Canvas2;

var BgShape;

var BgColorR;
var BgColorG;
var BgColorB;

var IconColorR;
var IconColorG;
var IconColorB;

var iconDir;
var iconName;

var LastBgSrc;

function __init(a, b, c, d, e) {
	Dimensions = a;
	NewDimensions = b;
	Padding = c;
	
	iconDir = d;
	iconName = e;
	
	BgShape = '';
	BgColorR = 255;
	BgColorG = 255;
	BgColorB = 255;
	
	IconColorR = 255;
	IconColorG = 255;
	IconColorB = 255;
	
	console.log("Customization script and UI initiated.");
}

function _update_var1() {
	
	NewDimensions = document.forms['main']['size'].value;
	
	if(NewDimensions == '1') { Dimensions = '16'; document.forms['main']['padding'].max = '7'; }
	else if(NewDimensions == '2') { Dimensions = '24'; document.forms['main']['padding'].max = '7'; }
	else if(NewDimensions == '3') { Dimensions = '32'; document.forms['main']['padding'].max = '10'; }
	else if(NewDimensions == '4') { Dimensions = '48'; document.forms['main']['padding'].max = '15'; }
	else if(NewDimensions == '5') { Dimensions = '128'; document.forms['main']['padding'].max = '39'; }
	else if(NewDimensions == '6') { Dimensions = '256'; document.forms['main']['padding'].max = '79'; }
	
	SizeNum = parseFloat(Dimensions);
	Padding = Math.floor(SizeNum / 4);
	if(Padding < 6) { Padding = 6; }
	document.forms['main']['padding'].value = Padding;
	
	document.getElementById("PaddingPx").innerHTML = Padding + " px";
	document.getElementById("SizePx").innerHTML = Dimensions + " px";
	
	_canvas_redraw();
}

function _update_var2() {
	Padding = document.forms['main']['padding'].value;
	document.getElementById("PaddingPx").innerHTML = Padding + " px";
	
	_canvas_redraw();
}

function _set_shape(shapeName, shapeButton) {
	BgShape = shapeName;
	
	document.getElementById("Bg1").className = 'BgChoice Float Left';
	document.getElementById("Bg2").className = 'BgChoice Float Left';
	document.getElementById("Bg3").className = 'BgChoice Float Left';
	document.getElementById("Bg4").className = 'BgChoice Float Left';
	shapeButton.className = 'BgChoice Selected Float Left';
	
	console.log("Shape changed to '" + BgShape + "'");
	
	if(shapeName != '') {
		document.getElementById("BgColorOption").className = "Showing";
	}
	else {
		document.getElementById("BgColorOption").className = "Hidden";
	}
	
	_canvas_redraw();
}

function set_bg_color(rgb) {
	BgColorR = Math.round(255 * rgb[0]).toString();
	BgColorG = Math.round(255 * rgb[1]).toString();
	BgColorB = Math.round(255 * rgb[2]).toString();
	
	console.log("Background color changed to {" + BgColorR + ", " + BgColorG + ", " + BgColorB + "}");
	
	_canvas_redraw();
}

function set_icon_color(rgb) {
	IconColorR = Math.round(255 * rgb[0]).toString();
	IconColorG = Math.round(255 * rgb[1]).toString();
	IconColorB = Math.round(255 * rgb[2]).toString();
	
	console.log("Foreground color changed to {" + BgColorR + ", " + BgColorG + ", " + BgColorB + "}");
	
	_canvas_redraw();
}

function MakeBgURL(Shape) {
	var BgUrl = 'gd/makebg.php';
	BgUrl += '?i=images/' + Shape;
	BgUrl += '&r=' + BgColorR + '&g=' + BgColorG + '&b=' + BgColorB;
	BgUrl += '&x=' + Dimensions + '&y=' + Dimensions;
	
	return BgUrl;
}

function MakeFgURL(Icon) {
	var BgUrl = 'gd/makefg.php';
	BgUrl += '?i=' + Icon;
	BgUrl += '&r=' + IconColorR + '&g=' + IconColorG + '&b=' + IconColorB;
	
	return BgUrl;
}

function _canvas_redraw() {
	Canvas = document.getElementById("Canvas");
	Canvas2 = document.getElementById("Canvas2");
	
	var NewHTML = '<div style="width: ' + Dimensions + 'px; height: ' + Dimensions + 'px; position: relative;">';
	
	if(BgShape != '') {
		if(document.getElementById("BgShapeImg") == null || LastBgSrc != MakeBgURL(BgShape)) {
			
			LastBgSrc = MakeBgURL(BgShape);
			
			console.log("Reloading BG image.");
			
			NewHTML2 = '<div style="width: ' + Dimensions + 'px; height: ' + Dimensions + 'px; position:relative;">';
			NewHTML2 += '<img id="BgShapeImg" src="' + MakeBgURL(BgShape) + '" style="position: absolute; top: 0; left: 0; width: 100%; height: 100%; z-index: 1;">';
			NewHTML2 += '</div>';
			
			Canvas2.innerHTML = NewHTML2;
		}
	}
	else {
		Canvas2.innerHTML = '';
	}
	
	SizeNum = parseFloat(Dimensions);
	PaddingNum = parseFloat(Padding);
	NewWidthNum = (SizeNum - PaddingNum - PaddingNum);
	NewWidth = NewWidthNum.toString();
	
	NewHTML += '<div style="position: absolute; top: ' + Padding + 'px; left: ' + Padding + 'px; z-index: 10;">';
	NewHTML += '<img src="' + MakeFgURL('icons/' + iconDir + '/' + iconName) + '" width="' + NewWidth + '" alt="Preview">';
	NewHTML += '</div></div>';
	
	if(NewWidthNum < 1) {
		NewHTML = '';
		console.log("A fault occured when drawing the canvas. Icon.Width < 0");
	}
	
	Canvas.innerHTML = NewHTML;
}

function _download_icon_png() {
	var DownloadURL = '';
	
	DownloadURL += "gd/download-png.php";
	DownloadURL += "?size=" + Dimensions;
	DownloadURL += "&padding=" + Padding;
	DownloadURL += "&icon=icons/" + iconDir + "/" + iconName;
	DownloadURL += "&in=" + iconName;
	DownloadURL += "&bgShape=" + BgShape;
	DownloadURL += "&bgColorR=" + BgColorR;
	DownloadURL += "&bgColorG=" + BgColorG;
	DownloadURL += "&bgColorB=" + BgColorB;
	DownloadURL += "&iconColorR=" + IconColorR;
	DownloadURL += "&iconColorG=" + IconColorG;
	DownloadURL += "&iconColorB=" + IconColorB;
	
	window.location = DownloadURL;
}

function _download_icon_gif() {
	var DownloadURL = '';
	
	DownloadURL += "gd/download-gif.php";
	DownloadURL += "?size=" + Dimensions;
	DownloadURL += "&padding=" + Padding;
	DownloadURL += "&icon=icons/" + iconDir + "/" + iconName;
	DownloadURL += "&in=" + iconName;
	DownloadURL += "&bgShape=" + BgShape;
	DownloadURL += "&bgColorR=" + BgColorR;
	DownloadURL += "&bgColorG=" + BgColorG;
	DownloadURL += "&bgColorB=" + BgColorB;
	DownloadURL += "&iconColorR=" + IconColorR;
	DownloadURL += "&iconColorG=" + IconColorG;
	DownloadURL += "&iconColorB=" + IconColorB;
	
	window.location = DownloadURL;
}