<?php
	require "config.php";
	
	$iconName = $_GET['icon'];
	$iconDir = $_GET['dir'];
?>
<!DOCTYPE HTML>
<html>
	<head>
		<title><?=$websiteName;?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		
		<link rel="stylesheet" type="text/css" href="css/master.css" />
		
		<style>
			input[type=range]:first-of-type {
			  width: 200px;
			}
			</style>
		<script src="https://raw.github.com/fryn/html5slider/master/html5slider.js"></script>
		<script type="text/javascript" src="js/jscolor/jscolor.js"></script>
	</head>
	<body>
		<div class="HeaderBar">
			<div class="Container" style="width: 940px;">
				<div class="Float Left">
					<h1><a href="./"><?=$websiteName;?></a></h1>
				</div>
				<div class="Float Clear"></div>
			</div>
		</div>
		<div class="DocumentBar">
			
			<script type="text/javascript" src="js/js__customizer.js"></script>
			<script type="text/javascript">
				__init(
					'128',
					'128',
					'29',
					'<?=$iconDir;?>',
					'<?=$iconName;?>'
				);
			</script>
			
			<div class="Container">
				<div class="Float Left" style="margin-bottom: 3px;"><h2><?=str_replace(".png", "", $iconName);?></h2></div>
				<div class="Float Right"><a href="index.php?c=<?=$iconDir;?>">Back to Browsing</a></div>
				<div class="Float Clear"></div>
				
				<div class="Float Left" style="position: relative; width: 400px; border: 1px solid #bbb; border-right: 0px; height: 575px; background: #f6f6f6; padding: 15px;">
					<form id="main">
						<div class="SettingsPane" style="padding: 10px; ">
						
							<!-- Dimensions -->
							
							<div style="margin-bottom: 0px;">
								<div class="Float Left" style="width: 110px; font-weight: bold;">Dimensions</div>
								<div class="Float Left">
									<input type="range" name="size" min="1" max="6" style="width: 200px; margin-top: -1px;" value="5" onchange="_update_var1();">
								</div>
								<div class="Float Left" style="padding-left: 10px;" id="SizePx">
									128 px
								</div>
								<div class="Float Clear"></div>
							</div>
							<div style="position: relative; margin-bottom: 36px;">
								<div style="position: absolute; top: 0px; left: 110px; font-size: 12px;">16</div>
								<div style="position: absolute; top: 0px; left: 148px; font-size: 12px;">24</div>
								<div style="position: absolute; top: 0px; left: 186px; font-size: 12px;">36</div>
								<div style="position: absolute; top: 0px; left: 223px; font-size: 12px;">48</div>
								<div style="position: absolute; top: 0px; left: 257px; font-size: 12px;">128</div>
								<div style="position: absolute; top: 0px; left: 297px; font-size: 12px;">256</div>
							</div>
							
							<!-- Padding -->
							
							<div style="margin-bottom: 56px;">
								<div class="Float Left" style="width: 110px; font-weight: bold;">Padding</div>
								<div class="Float Left">
									<input type="range" name="padding" min="0" max="39" style="width: 200px; margin-top: -1px;" value="29" onchange="_update_var2();">
								</div>
								<div class="Float Left" style="padding-left: 10px;" id="PaddingPx">
									29 px
								</div>
								<div class="Float Clear"></div>
							</div>
							
							<!-- Background -->
							
							<div style="margin-bottom: 56px;"><div style="margin-bottom: 16px;">
								<div class="Float Left" style="width: 110px; font-weight: bold;">Background Shape</div>
								<div class="Float Left">
									<div id="Bg1" class="BgChoice Float Left" style="width: 50px; height: 50px; margin-right: 16px;" onclick="_set_shape('CircleBG.png', this);">
										<img src="images/CircleBG.png" width='30px' height='30px' style="margin: 10px;" />
									</div>
									<div id="Bg2" class="BgChoice Float Left" style="width: 50px; height: 50px; margin-right: 16px;" onclick="_set_shape('CircleOlBG.png', this);">
										<img src="images/CircleOlBG.png" width='30px' height='30px' style="margin: 10px;" />
									</div>
									<div id="Bg3" class="BgChoice Float Left" style="width: 50px; height: 50px; margin-right: 16px;" onclick="_set_shape('SquareBG.png', this);">
										<img src="images/SquareBG.png" width='30px' height='30px' style="margin: 10px;" />
									</div>
									<div id="Bg4" class="BgChoice Selected Float Left" style="width: 50px; height: 50px; margin-right: 16px;" onclick="_set_shape('', this);">
										<div style="width: 30px; height: 30px; margin: 10px; background: url('images/TransparentBg.png');">&nbsp;</div>
									</div>
								</div>
								<div class="Float Clear"></div>
							</div>
							
							<!-- Background Color -->
							
							<div id="BgColorOption" style="margin-bottom: 16px;" class="Hidden">
								<div class="Float Left" style="width: 110px; font-weight: bold;">Background Color</div>
								<div class="Float Left">
									<input class="color" name="bgColor" onchange="set_bg_color(this.color.rgb);">
								</div>
								<div class="Float Clear"></div>
							</div>
							
							<!-- Icon Color -->
							
							<div style="margin-bottom: 16px;">
								<div class="Float Left" style="width: 110px; font-weight: bold;">Icon Color</div>
								<div class="Float Left">
									<input class="color" name="bgColor2" onchange="set_icon_color(this.color.rgb);">
								</div>
								<div class="Float Clear"></div>
							</div></div>
							
							<div style="position: absolute; bottom: 25px; left: 25px; width: 375px;">
								<?php if($enableDownloadPNG) { ?><a href="javascript: void(0);" onclick="_download_icon_png();" class="callaction png">Download as PNG</a><?php } ?>
								<?php if($enableDownloadGIF) { ?><a href="javascript: void(0);" onclick="_download_icon_gif();" class="callaction gif" style="margin-top: 10px;">Download as GIF</a><?php } ?>
							</div>
							
						</div>
					</form>
				</div>
				<div class="Float Left" style="width: 535px; height: 575px; background: #333; border: 1px solid #333; padding: 15px; position: relative;">
					<div id="Canvas_Container" style="background: url('images/Transparent.png'); height: 575px; width: 535px;">
						<table width='100%' style='height: 100%;'>
							<tr style='vertical-align: middle !important;'>
								<td style='vertical-align: middle !important;'>
									<center>
										<div id="Canvas2">
											<!-- default code for canvas item background drawing -->
											<!--<div style="width: 128px; height: 128px; position:relative;">
												<img src="images/CircleOlBG.png" style="position: absolute; top: 0; left: 0; width: 100%; height: 100%; z-index: 1;">
											</div>-->
										</div>
									</center>
								</td>
							</tr>
						</table>
					</div>
					<div id="Canvas_Container" style="height: 575px; position: absolute; top: 15px; left: 15px; width: 535px;">
						<table width='100%' style='height: 100%;'>
							<tr style='vertical-align: middle !important;'>
								<td style='vertical-align: middle !important;'>
									<center>
										<div id="Canvas">
											<!-- default code for canvas item drawing -->
											
											<!--<div style="width: 128px; height: 128px; position:relative;">
												<div style="position: absolute; top: 29px; left: 29px; z-index: 10;">
													<img src="icons/<?=$iconDir;?>/<?=$iconName;?>" width='70px' alt="<?=str_replace('.png', '', $iconName);?>">
												</div>
											</div>-->
										</div>
									</center>
								</td>
							</tr>
						</table>
					</div>
				</div>
				<div class="Float Clear"></div>
			</div>
			
			<script type="text/javascript">
				_canvas_redraw();
			</script>
			
		</div>
		<div class="FooterBar">
			<div class="Container">
				<div class="Float Left">
					Copyright &copy; <?=$websiteCopyrightYear;?> <?=$websiteOrganization;?>
				</div>
				<div class="Float Right">
					<?php if($showContactUsButton) { ?><a href="mailto:<?=$websiteEmail;?>">Contact Us</a><?php } ?>
				</div>
				<div class="Float Clear"></div>
			</div>
		</div>
	</body>
</html>
