<?php
	require "config.php";
	
	$browsing = "Application";
	if($_GET['c']) $browsing = $_GET['c'];
?>
<!DOCTYPE HTML>
<html>
	<head>
		<title><?=$websiteName;?></title>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
		
		<link rel="stylesheet" type="text/css" href="css/master.css" />
	</head>
	<body>
		<div class="HeaderBar">
			<div class="Container" style="width: 940px;">
				<div class="Float Left">
					<h1><a href="./"><?=$websiteName;?></a></h1>
				</div>
				<div class="Float Clear"></div>
			</div>
		</div>
		<div class="DocumentBar">
			<div class="Container">
				<div class="Sidebar Navigation">
					<h2>Icon Category</h2>
					
					<div class="BrowseBox">
						<?php
							require "includes/navigation.php";
						?>
					</div>
				</div>
				<div class="Browse">
					<!--[if IE]>
						<div style="color:red; margin-bottom: 10px;">
							Internet Explorer does not render our images in full-quality. Please keep in mind that the actual images are much more smooth.
						</div>
					<![endif]-->
					
					<h2><?=$browsing;?></h2>
					
					<div class="BrowseBox">
						<?php
							$directory = "icons/$browsing/";
							$images = glob($directory . "*.png");
							
							foreach($images as $icon) {
								$icon = str_replace("icons/$browsing/", "", $icon);
								
								$iconName = str_replace(".png", "", $icon);
								if(strlen($iconName) > 7) {
									$iconName = substr($iconName, 0, 7) . "...";
								}
								
								if($useFastImageLoading) {
									$path = "icons/$browsing/$icon";
									$type = pathinfo($path, PATHINFO_EXTENSION);
									$data = file_get_contents($path);
									$base64 = 'data:image/' . $type . ';base64,' . base64_encode($data);
								}
								else {
									$base64 = "icons/$browsing/$icon";
								}
						?>
						<div class="Item">
							<center><a href="customize.php?dir=<?=$browsing;?>&icon=<?=$icon;?>">
								<div class="Thumbnail">
									<img src="<?=$base64;?>" title="<?=str_replace(".png", "", $icon);?>" alt="<?=str_replace(".png", "", $icon);?>">
								</div>
								<div class="Title"><?=$iconName;?></div>
								<div class="Options">
									<img src="./images/Edit.png" onMouseOver="this.src='./images/Edit-On.png';" onMouseOut="this.src='./images/Edit.png';" alt="Edit">
								</div>
							</a></center>
						</div>
						<?php
								unset($base64); // remove used memory
							}
						?>
					</div>
				</div>
				<div class="Float Clear"></div>
			</div>
		</div>
		<div class="FooterBar">
			<div class="Container">
				<div class="Float Left">
					Copyright &copy; <?=$websiteCopyrightYear;?> <?=$websiteOrganization;?>
				</div>
				<div class="Float Right">
					<?php if($showContactUsButton) { ?><a href="mailto:<?=$websiteEmail;?>">Contact Us</a><?php } ?>
				</div>
				<div class="Float Clear"></div>
			</div>
		</div>
	</body>
</html>
